DECLARE SUB initial (y!(), ybest!(), n!, tpath!, tbest!, dn!, delta!, rx!, ry!)
DECLARE SUB path (y!(), ybest!(), n!, tpath!, tbest!, dn!, delta!, rx!, ry!)
DECLARE SUB boundary (y!(), i!, deltax!, rx!, ry!)
DECLARE SUB newpath (y!(), ybest!(), i!, n!, tpath!, tbest!, dn!, delta!, rx!, ry!)
DECLARE SUB pathtime (n!, i!, dn!, delta!, y!(), ybest!(), tpath!, tbest!)
DECLARE SUB erese (i!, y!(), rx!, ry!)
DECLARE SUB drow (i!, y!(), ybest!())

REM program fermat.
DIM y(0 TO 30), ybest(0 TO 30)
CALL initial(y(), ybest(), n, tpath, tbest, dn, delta, rx, ry)
CALL path(y(), ybest(), n, tpath, tbest, dn, delta, rx, ry)
END

SUB boundary (y(), i, deltax, rx, ry)
  LINE (i, y(i) - ry)-(i, y(i) + ry)
  i = i + deltax
  PSET (i - rx, y(i) - ry), 0
END SUB

SUB drow (i, y(), ybest())
  LINE (i, y(i))-(i - 1, y(i - 1)), 1
  LINE (i, y(i))-(i + 1, y(i + 1)), 1
  LINE (i, ybest(i))-(i - 1, ybest(i - 1)), 4
  LINE (i, ybest(i))-(i + 1, ybest(i + 1)), 4
END SUB

SUB erese (i, y(), rx, ry)
  LINE (i - rx, y(i) - ry)-(i + rx, y(i) + ry), 0
  LINE (i, y(i))-(i - 1, y(i - 1)), 0
  LINE (i, y(i))-(i + 1, y(i + 1)), 0
END SUB

SUB initial (y(), ybest(), n, tpath, tbest, dn, delta, rx, ry)
  INPUT "⢮ ⥩= "; n
  INPUT "饭 ⥫ ५= "; dn
  INPUT "y-न ⥪= "; y(n)
  y(0) = -y(n)
  ybest(0) = y(0)
  ybest(n) = y(n)
  slope = (y(n) - y(0)) / (n)
  FOR i = 1 TO n
    y(i) = y(0) + slope * i
    ybest(i) = y(i)
  NEXT i
  SCREEN 9
  VIEW (93, 93)-(435, 335)
  WINDOW (-1, y(0))-(n + 1, y(n))
  LINE (0, y(0))-(n, y(n)), 10, B
  FOR i = 1 TO (n - 1)
    LINE (i, y(0))-(i, y(n)), 10
  NEXT i
  ry = .1
  rx = .02
  LINE (-rx, y(0) - ry)-(rx, y(0) + ry), 10, BF
  LINE (n - rx, y(n) - ry)-(n + rx, y(n) + ry), 10, BF
  FOR i = 1 TO n
    LINE (i, y(i))-(i - 1, y(i - 1)), 5
    LINE (i, ybest(i))-(i - 1, ybest(i - 1)), 5
    dy2 = (y(i) - y(i - 1)) * (y(i) - y(i - 1))
    length = SQR(1 + dy2)
    tpath = tpath + length * (1 + (i - 1) * dn)
  NEXT i
  tbest = tpath
  delta = .01 * ABS(y(n) - y(0))
  VIEW PRINT 1 TO 3
  PRINT "६ ஡ = "; tpath
  PRINT "襥   ਠ⮢ ६= "; tbest
END SUB

SUB newpath (y(), ybest(), i, n, tpath, tbest, dn, delta, rx, ry)
  CALL erese(i, y(), rx, ry)
  y(i) = y(i) + delta
  CALL drow(i, y(), ybest())
  PSET (i - rx, y(i) - ry)
  CALL pathtime(n, i, dn, delta, y(), ybest(), tpath, tbest)
END SUB

SUB path (y(), ybest(), n, tpath, tbest, dn, delta, rx, ry)
  i = 1
  PSET (i - rx, y(i) - ry)
  DO
    choise$ = INKEY$
    SELECT CASE choise$
      CASE "l"
      IF i > 1 THEN
        deltax = -1
        CALL boundary(y(), i, deltax, rx, ry)
      END IF
      CASE "r"
      IF i < n - 1 THEN
        deltax = 1
        CALL boundary(y(), i, deltax, rx, ry)
      END IF
      CASE "u"
        CALL newpath(y(), ybest(), i, n, tpath, tbest, dn, delta, rx, ry)
      CASE "d"
        CALL newpath(y(), ybest(), i, n, tpath, tbest, dn, -delta, rx, ry)
      CASE ELSE
    END SELECT
  LOOP UNTIL INKEY$ = "s"
END SUB

SUB pathtime (n, i, dn, delta, y(), ybest(), tpath, tbest)
  v1 = 1 / (1 + (i - 1) * dn)
  v2 = 1 / (1 + i * dn)
  dy2 = (y(i) - y(i - 1)) * (y(i) - y(i - 1))
  t1 = SQR(1 + dy2) / v1
  dy2 = (y(i) - y(i + 1)) * (y(i) - y(i + 1))
  t2 = SQR(1 + dy2) / v2
  dy2 = (y(i) - delta - y(i - 1)) * (y(i) - delta - y(i - 1))
  t1old = SQR(1 + dy2) / v1
  dy2 = (y(i) - delta - y(i + 1)) * (y(i) - delta - y(i + 1))
  t2old = SQR(1 + dy2) / v2
  tpath = tpath + t1 + t2 - t1old - t2old
  IF tpath <= tbest THEN
    tbest = tpath
    FOR j = 1 TO n
      LINE (j, ybest(j))-(j - 1, ybest(j - 1)), 0
      LINE (j, y(j))-(j - 1, y(j - 1))
    NEXT j
    FOR j = 1 TO n
      ybest(j) = y(j)
    NEXT j
  END IF
  IF delta > 0 THEN
    LINE (i, y(i) - 2 * delta)-(i, y(i) + delta), 10
  ELSE
    LINE (i, y(i) + delta)-(i, y(i) - 2 * delta), 10
  END IF
  PSET (1, 1)
  VIEW PRINT 4 TO 7
  PRINT "६ ஡ ="; tpath
  PRINT "襥   ਠ⮢ ६="; tbest
END SUB

