(************************************************************)
(*							    *)
(*     ணࠬ  室  ਧ      *)
(*							    *)
(************************************************************)
(*							    *)
(*	 祭 ࠭ ࠩ  ணࠬ ᫥- *)
(*      BINOBJ EGAVGA.BGI EGAVGA EGAVGA_DRIV   *)
(*   ப DOS.   ணࠬ ᫥ - *)
(* ⠢ ᫮ {$define IncDriver}.			    *)
(*	 ⨢ 砥  ࠡ ணࠬ ᫥	    *)
(*  䠩 EGAVGA.BGI  ⥪饬 ⠫		    *)
(*							    *)
(************************************************************)

program Polarize;
  {$define z817}	{ -  襭  8.17 }
  { $define IncDriver}	{ -  祭 ࠩ }
uses Crt, Graph;
var
  Gd, Gm, Er : Integer;
  Ratio, Phase, Lambda, Ex0, Ey0, nx, ny,
  Lout, dt, w, c, k, t, Lin, Ex, Ey, Lx, Ly,
  Width, Spacing, ExOut, EyOut : Real;

{$ifdef IncDriver}
  procedure EGAVGA_Driv; {$L egavga.obj} external;
{$endif}

function DkX(Kx : Real) : Integer;
begin
  DkX:=68+Round(Kx)
end;

function DkY(Ky : Real) : Integer;
begin
  DkY:=100-Round(Ky)
end;

procedure Initial;
begin
  TextColor(Cyan); Write('⭮襭 (<=1) Ex  Ey     = ');
  TextColor(LightRed); ReadLn(Ratio);
  TextColor(Cyan); Write(' 䠧 (ࠤ)      = ');
  TextColor(LightRed); ReadLn(Phase);
  TextColor(Cyan); Write('                  = ');
  TextColor(LightRed); ReadLn(Lambda);
  {$ifdef z817}
    TextColor(Cyan); Write('ਭ ⠫ ()       = ');
    TextColor(LightRed); ReadLn(Width);
    TextColor(Cyan); Write('⥫ ५  X = ');
    TextColor(LightRed); ReadLn(nx);
    TextColor(Cyan); Write('⥫ ५  Y = ');
    TextColor(LightRed); ReadLn(ny);
  {$endif}
  Phase:=Phase*Pi/180; Ex0:=55; Ey0:=Ex0*Ratio; ClearDevice;
  {$ifdef z817}
    GoToXY(65,4); Write('室 ');
  {$endif}
  TextColor(LightMagenta); GoToXY(3,4);
  Write('室 ')
end;

procedure Polar;
begin
  Spacing:=2.5*Ex0; Lx:=0.9*Ex0; TextColor(Yellow);
  GoToXY(3,13); Write('Ex'); Ly:=Lx+Spacing;
  GoToXY(32,4); Write('Ey'); Lin:=Ly+Spacing;
  TextColor(LightCyan); GoToXY(50,25); Write('E .');
  {$ifdef z817}
    Lout:=Lin+Spacing; GoToXY(70,25); Write('E .');
  {$endif}
  t:=0; k:=2*Pi/Lambda; c:=3e+11;
  w:=k*c; dt:=0.1/w; SetColor(White);
  Line(DkX(Lx-Ex0),DkY(0),DkX(Lx+Ex0),DkY(0));
  Line(DkX(Ly),DkY(-Ey0),DkX(Ly),DkY(Ey0));
  repeat
    t:=t+dt; Ex:=Ex0*Cos(w*t-Phase); Ey:=Ey0*Cos(w*t);
    {$ifdef z817}
      ExOut:=Ex0*Cos(w*t-k*Width/nx-Phase);
      EyOut:=Ey0*Cos(w*t-k*Width/ny); SetColor(Green);
      Line(DkX(Lout),DkY(0),DkX(Lout+ExOut),DkY(EyOut));
    {$endif}
    SetColor(Brown); Delay(50);
    Line(DkX(Lin),DkY(0),DkX(Lin+Ex),DkY(Ey))
  until KeyPressed
end;

begin
  {$ifdef IncDriver}
    if RegisterBGIDriver(@EGAVGA_Driv)<0 then
    begin
      WriteLn('訡  ॣ樨 ࠩ'); Halt(1)
    end;
  {$endif}
  Gd:=VGA; Gm:=VGALo; DirectVideo:=false;
  InitGraph(Gd, Gm, ''); Er:=GraphResult;
  if Er<>grOk then
  begin
    WriteLn('訡  ⠭ ᪮ ०: ');
    WriteLn('   ', GraphErrorMsg(Er)); Halt(1)
  end;
  Initial; Polar; CloseGraph;
  while KeyPressed do ReadKey
end { Polarize }.
